VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NetworkInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Network Information
'
' 29 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------
' API's to get network information

Private Declare Function SetComputerName Lib "kernel32" Alias "SetComputerNameA" (ByVal lpComputerName As String) As Long
Private Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Private Declare Function WNetGetUser Lib "mpr.dll" Alias "WNetGetUserA" (ByVal lpName As String, ByVal lpUserName As String, lpnLength As Long) As Long


'------------------------------------------------------------------
' Get the computer name

Public Property Get ComputerName() As String
  Dim Buffer As String
  Dim BufferLen As Long
  BufferLen = 256
  Buffer = Space(BufferLen)
  
  If GetComputerName(Buffer, BufferLen) <> 0 Then
    ComputerName = Left$(Buffer, BufferLen)
  End If
End Property

' This needs a restart
Public Property Let ComputerName(Name As String)
  If SetComputerName(Name) = 0 Then _
    Err.Raise 12345, "Computer Name", "Could not set computer name!"
End Property


'------------------------------------------------------------------
' Get the user name

Public Property Get UserName() As String
  Dim RetVal As Long
  Dim Buffer As String
  Dim BufferLen As Long
  
  BufferLen = 128
  Buffer = Space(BufferLen)
  
  RetVal = WNetGetUser("", Buffer, BufferLen)
  
  Select Case RetVal
    Case 0
      UserName = Left(Buffer, InStr(1, Buffer, Chr(0)) - 1)
    Case 1245
      UserName = "Windows" ' Not logged on
    Case Else
      Err.Raise 12345, "Computer Name", "Could not get user name!"
  End Select
End Property

